"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Ellipsis = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _value = require("../value");
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["style", "render", "count", "level"];
function getType(value) {
  // Check for null explicitly as typeof null === 'object'
  if (value === null) {
    return 'null';
  }

  // Check for Array
  if (Array.isArray(value)) {
    return 'Array';
  }

  // Check for special object types: Set and Map
  if (value instanceof Set) {
    return 'Set';
  }
  if (value instanceof Map) {
    return 'Map';
  }

  // Check for object (this is placed after the checks for Array, Set, and Map)
  if ((0, _typeof2["default"])(value) === 'object') {
    return 'Object';
  }

  // Covers undefined and other primitive types
  return (0, _typeof2["default"])(value);
}
function getSubValue(value) {
  switch (getType(value)) {
    case 'Array':
      return '[...]';
    case 'Object':
      return '{...}';
    default:
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_value.ValueView, {
        value: value,
        displayDataTypes: false,
        displayObjectSize: false,
        isSet: false,
        enableClipboard: false,
        indentWidth: 4
      });
  }
}
function getEllipsisStr(obj) {
  var result = '';
  if ((0, _typeof2["default"])(obj) === 'object' && !Array.isArray(obj)) {
    console.log('strArr', Object.entries(obj));
    result = /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
      style: {
        margin: '0 2px'
      },
      className: "w-rjv-ellipsis-wrapper",
      children: Object.entries(obj).map(function (_ref, index) {
        var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
          key = _ref2[0],
          value = _ref2[1];
        return /*#__PURE__*/(0, _jsxRuntime.jsxs)("span", {
          children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)("span", {
            className: "w-rjv-object-key",
            style: {
              opacity: 0.4
            },
            children: [key, ":"]
          }), /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
            className: "w-rjv-ellipsis-value",
            children: getSubValue(value)
          }), index !== Object.entries(obj).length - 1 ? ', ' : '']
        });
      })
    });
  } else if (Array.isArray(obj)) {
    result = /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
      children: obj.map(function (item, index) {
        return /*#__PURE__*/(0, _jsxRuntime.jsxs)("span", {
          className: "w-rjv-ellipsis-wrapper w-rjv-ellipsis-array-wrapper",
          children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
            className: "w-rjv-ellipsis-value",
            children: getSubValue(item)
          }), index !== obj.length - 1 ? ', ' : '']
        });
      })
    });
  }
  console.log('result', result);
  return result;
}
var Ellipsis = exports.Ellipsis = function Ellipsis(_ref3) {
  var style = _ref3.style,
    render = _ref3.render,
    count = _ref3.count,
    level = _ref3.level,
    props = (0, _objectWithoutProperties2["default"])(_ref3, _excluded);
  var styl = (0, _objectSpread2["default"])({
    cursor: 'pointer'
  }, style);
  var className = "w-rjv-ellipsis ".concat(props.className || '');
  if (render) return render((0, _objectSpread2["default"])((0, _objectSpread2["default"])({
    style: styl,
    count: count,
    level: level
  }, props), {}, {
    className: className
  }));
  console.log('valueData', props.valueData);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)("span", (0, _objectSpread2["default"])((0, _objectSpread2["default"])({
    className: className,
    style: styl
  }, props), {}, {
    children: getEllipsisStr(props.valueData)
  }));
};
Ellipsis.displayName = 'JVR.Ellipsis';